/***************************************************************************
 *
 *  Messung der Akkuspannung
 *  ADC muss vorher inialisiert sein, siehe adc.h
 *
 ***************************************************************************/
#include <inttypes.h>
#include <avr/io.h>
#include "adc.h"
#include "akku.h"

uint8_t voltage_levels[] = 
	{
		25, 	//0  0-10% rot blinkend
		51,		//1 10-20% rot
		90,		//2 20-35% gelb blinkend
		128, 	//3 35-50% gelb
		150, 	//4 50-60% grn blinkend
		255 	//5 60-100% grn
	};


/***************************************************************************
 * 
 * Initialisierung
 * ADC starten
 * Status auf 0
 * 
 ***************************************************************************/
void akkuInitialize(void)
{
	adcInitialize();
	akkustatus = 0;
}


/***************************************************************************
 * 
 * Akkustand ermitteln
 * 4 Messungen, dann Mittelwert zum Stabilisieren des Wertes - wackelt dennoch :(
 * Status aus Tabelle ableiten
 * 
 ***************************************************************************/
void akkuGetStatus(void)
{
	uint16_t adcSum=0;
	uint8_t i;
	uint8_t temp;


  	for(i=0;i<4;i++)
  	{
    	adcSum += adcReadValue(); // Wandlungsergebnisse aufaddieren
  	}

	temp = (adcSum >> 2); //Wert als 8bit zwischenspeichern
	
	akkustatus = 0;
  	for(akkustatus=0;akkustatus<=5;akkustatus++)
	{
		if (temp < voltage_levels[akkustatus])
		{
			break;
		}
	}

}
